﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Tree
{
    public partial class TreeForm : Form
    {
        public TreeForm()
        {
            InitializeComponent();

            tree.ShowNodeToolTips = true;

            // using System.IO;
            DirectoryInfo d = new DirectoryInfo ("../../../..");
            this.Text = d.FullName;

            MyNode branch = new MyNode ();
            branch.Text = d.Name;
            branch.ToolTipText = d.FullName;
            branch.ForeColor = Color.Red;
            branch.path = d.FullName;
            branch.directory = true;
            tree.Nodes.Add (branch);

            displayDir (branch, d);
            // branch.ExpandAll();
            branch.Expand();
        }

        private void displayDir (MyNode target, DirectoryInfo dir, int level = 1)
        {
            DirectoryInfo[] items = dir.GetDirectories();
            foreach (var item in items)
            {
                MyNode node = new MyNode();
                node.Text = item.Name;
                node.ToolTipText = item.FullName;
                node.ForeColor = Color.Red;
                node.path = item.FullName;
                node.directory = true;
                target.Nodes.Add (node);
                if (level > 1)
                   displayDir (node, item, level-1);
            }

            FileInfo[] file_items = dir.GetFiles();
            foreach (var item in file_items)
            {
                MyNode node = new MyNode();
                node.Text = item.Name;
                node.ToolTipText = item.FullName;
                node.ForeColor = Color.Blue;
                node.path = item.FullName;
                target.Nodes.Add(node);
            }

            target.complete = true;
        }

        private void tree_BeforeExpand (object sender, TreeViewCancelEventArgs e)
        {
            TreeNode branch = e.Node;
            foreach (TreeNode tree_item in branch.Nodes)
            {
                if (tree_item is MyNode)
                {
                    MyNode item = tree_item as MyNode;
                    if (item.directory && ! item.complete)
                       displayDir (item, new DirectoryInfo (item.path));
                }
            }
        }
    }
}
